using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using UnityEngine;
using System.IO;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            string[] wordsArray = new string[]
            {
                "1000kg Weight", "9mm Pistol", "Acid Syringe", "Adrenaline Syringe", "AK-47", "Android", "Assault Rifle", "Atom Bomb", "Axe", "Baseball Bat", "Battery", "Bazooka", "Beam Rifle", "Blaster", "Blaster Rifle", "Blood Flask", "Blood Tank", "Bone Eating Syringe", "Bottle", "Brick", "Brick Cube", "Brick Wall", "Bulletproof Sheet", "Cardiopulmonary Bypass Machine", "Ceiling Turret", "Centrifuge", "Clamp", "Coagulation Syringe", "Cobblestone Wall", "Concrete slab", "Container Wagon", "Conveyor Belt", "Cooling Element", "Crate", "Crossbow", "Crossbow Bolt", "Crystal", "Death Syringe", "Defibrillator", "Detached 120mm Cannon", "Detached 30mm HEAT Cannon", "Detached Beam Cannon", "Detached Laser Cannon", "Detached Ray Cannon", "Detector", "Disassembler", "Dynamite", "EMP Generator", "Empty Syringe", "Energy Sword", "Fireworks", "Flamethrower", "Flashlight", "Flask", "Flintlock Pistol", "Floodlight", "Fluorescent Lamp", "Brick Cube", "Brick Wall", "Bulletproof Sheet", "Bus", "Bus Chair", "Button", "Capacitor Attachment", "Cardiopulmonary Bypass Machine", "Ceiling Turret", "Centrifuge", "Freeze Syringe", "Freezeray", "Fusion Bomb", "G1 Submachine Gun", "General Purpose Bomb", "Generator", "Glass Pane", "Gorse", "Grenade Launcher", "Gyroscope Stabiliser", "Hammer", "Handcannon", "Handgrenade", "Heart Monitor", "Human", "I-Beam", "Industrial Generator", "Jet Engine", "Jukebox", "Knife", "Knockout Syringe", "Lance", "Landmine"
            };

            GameObject BG2 = new GameObject();
            BG2.transform.position = new Vector3(2.5f, 3, 0);
            Sprite sprite = ModAPI.LoadSprite("Cursor.png", 2);
            SpriteRenderer sp2 = BG2.AddComponent<SpriteRenderer>();
            sp2.sprite = sprite;
            sp2.sortingOrder = 32767;
            sp2.color = new Color(UnityEngine.Random.Range(0f, 1f), UnityEngine.Random.Range(0f, 1f), UnityEngine.Random.Range(0f, 1f)); //new Color(0.25f, 0.4f, 1, 1);
            //BG2.FixColliders();
            GamepadInput bg = BG2.AddComponent<GamepadInput>();
            bg.Prefabs = wordsArray;
        } 
    }
    public class GamepadInput : MonoBehaviour
    {
        public string[] Prefabs;
        public float speed = 0.011f;
        public float rotationSpeed = 40f;
        private Transform rb;
        private GameObject sel;
        public Vector3 offset;
        private bool isSelecting = false;
        
        void Start()
        {
            rb = transform;
            ModAPI.OnItemRemoved += (sender, ev) => {
                GameObject Instance = ev.Instance;
                if (Instance == sel) { 
                    sel = null;
                    isSelecting = false;
                }
            };
        }

        void Update()
        {
            if (Input.GetKey(KeyCode.JoystickButton1)) { 
                speed = 3f; //0.005f;
                rotationSpeed = 20f;
            } else { 
                speed = 6f; //0.011f;
                rotationSpeed = 40f;
            }
            float moveHorizontal = Input.GetAxis("Horizontal")*speed;
            float moveVertical = Input.GetAxis("Vertical")*speed;

            float rotationHorizontal;
            if (Input.GetKey(KeyCode.JoystickButton4)) { 
                rotationHorizontal = 1*speed;
            } else if (Input.GetKey(KeyCode.JoystickButton5)) { 
                rotationHorizontal = -1*speed;
            } else { 
                rotationHorizontal = 0;
            }
            if (Input.GetKeyDown(KeyCode.JoystickButton3)) { 
                string ran = Prefabs.PickRandom<string>();
                SpawnableAsset pref = ModAPI.FindSpawnable(ran);
                GameObject ob = UnityEngine.Object.Instantiate<GameObject>(pref.Prefab, rb.position, Quaternion.identity);
                CatalogBehaviour.PerformMod(pref, ob);
                //ModAPI.InvokeItemSpawned((object) this, new UserSpawnEventArgs(ob, pref));
            }

            if (Input.GetKeyDown(KeyCode.JoystickButton8)) { 
                GameObject ob = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Human").Prefab, rb.position, Quaternion.identity);
                CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Human"), ob);
                //ModAPI.InvokeItemSpawned((object) this, new UserSpawnEventArgs(ob, ModAPI.FindSpawnable("Human")));
            }

            if (Input.GetKeyDown(KeyCode.JoystickButton9)) { 
                Vector3 Worldpos = Camera.main.ScreenToWorldPoint(Input.mousePosition);  
                rb.position = new Vector2(Worldpos.x, Worldpos.y);
            }

            Vector3 movement = new Vector3(moveHorizontal * Time.deltaTime, moveVertical * Time.deltaTime);
            transform.position += movement;
            Vector3 mousePosition = rb.position;
            
            if (isSelecting) { 
                sel.transform.position = mousePosition+offset;
                sel.transform.RotateAround(sel.transform.position+offset, Vector3.forward, (rotationHorizontal * rotationSpeed) * Time.deltaTime); //sel.transform.Rotate(0, 0, rotationHorizontal * rotationSpeed);
                
                //.Rotate(0, 0, rotationHorizontal*rotationSpeed);
            }

            if (Input.GetKeyDown(KeyCode.JoystickButton2))
            {
                if (!isSelecting) { 
                    Collider2D targetObject = Physics2D.OverlapPoint(mousePosition);
                    if (targetObject && !targetObject.gameObject.HasComponent<Undraggable>())
                    {
                        sel = targetObject.gameObject;
                        offset = sel.gameObject.transform.position-transform.position;
                        isSelecting = true;
                        if (sel.GetComponent<Rigidbody2D>()) { 
                            if (sel.GetComponent<Rigidbody2D>().bodyType != RigidbodyType2D.Static) { 
                                sel.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
                            }
                        }
                    }
                } else { 
                    if (sel) { 
                        if (sel.GetComponent<Rigidbody2D>()) { 
                            if (sel.GetComponent<Rigidbody2D>().bodyType == RigidbodyType2D.Static) { 
                                isSelecting = false;
                                sel.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Dynamic;
                                sel = null;
                            }
                        }
                    }
                }
            }

            if (Input.GetKeyDown(KeyCode.JoystickButton0))
            {
                Collider2D targetObject = Physics2D.OverlapPoint(mousePosition);
                if (sel != null) { 
                    if (sel.GetComponent<PhysicalBehaviour>()) {    
                        sel.BroadcastMessage("Use", (object) new ActivationPropagation(true, sender: sel), SendMessageOptions.DontRequireReceiver);
                    }
                } else if (targetObject != null) {
                    if (targetObject.gameObject.GetComponent<PhysicalBehaviour>()) {    
                        targetObject.gameObject.BroadcastMessage("Use", (object) new ActivationPropagation(true, sender: targetObject.gameObject), SendMessageOptions.DontRequireReceiver);
                    }
                }
            }
        }
    }
}
// Originally uploaded by 'pjstarr12'. Do not reupload without their explicit permission.
